--
-- FreezingWindows
-- einfrierende Scheiben
--
-- @author  Aranea
-- @date  /01/2015
--
-- Copyright (C) Aranea, All Rights Reserved.
--

FreezingWindows = {};

function FreezingWindows.prerequisitesPresent(specializations)
    return true;
end;

function FreezingWindows:load(xmlFile)
	self.setWindowCondition = SpecializationUtil.callSpecializationsFunction("setWindowCondition");
-- sound
	if self.isClient then
        local airConditionerSound = getXMLString(xmlFile, "vehicle.airConditionerSound#file");
        if airConditionerSound ~= nil and airConditionerSound ~= "" then
            airConditionerSound = Utils.getFilename(airConditionerSound, self.baseDirectory);
            self.airConditionerSound = createSample("airConditionerSound");
            loadSample(self.airConditionerSound, airConditionerSound, false);
            self.airConditionerSoundPitch = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.airConditionerSound#pitchOffset"), 1);
            self.airConditionerSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.airConditionerSound#volume"), 1);
            setSamplePitch(self.airConditionerSound, self.airConditionerSoundPitch);
        end;
	end;
-- variables
	self.isAirConditionerActive = false;
	self.airConditionerSoundEnabled = false;
	self.freezeAnimParts = false;
	self.isFrozen = false;
end;

function FreezingWindows:delete()
end;

function FreezingWindows:readStream(streamId, connection)
	local isAirConditionerActive = streamReadBool(streamId);
	local isFrozen = streamReadBool(streamId);
	self:setWindowCondition(isAirConditionerActive, isFrozen, true);
end;

function FreezingWindows:writeStream(streamId, connection)
	streamWriteBool(streamId, self.isAirConditionerActive, self.isFrozen);
end

function FreezingWindows:mouseEvent(posX, posY, isDown, isUp, button)
end;

function FreezingWindows:keyEvent(unicode, sym, modifier, isDown)
end;

function FreezingWindows:update(dt)
	if self.isClient and self:getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.AIRCONDITIONER) then
			self:setWindowCondition(not self.isAirConditionerActive, self.isFrozen);
		end;
	end;
end;

function FreezingWindows:updateTick(dt)
	if self.isClient then
		if self.isFrozen then
			if self.isAirConditionerActive then
				self:setWindowCondition(self.isAirConditionerActive, false); -- setEvent: is not frozen
			end;
		else -- not frozen
			if not self.isAirConditionerActive then
					if  g_currentMission.environment.dayTime > 350000 and g_currentMission.environment.dayTime < 28800000 then --1 - 8 Uhr 
				-- if g_currentMission.environment.currentRain ~= nil and g_currentMission.environment.timeSinceLastRain < 30 then
					self:setWindowCondition(self.isAirConditionerActive, true); -- setEvent: is frozen
				end;
				if  g_currentMission.environment.dayTime < 350000 and g_currentMission.environment.dayTime > 28800000 then
					self:setWindowCondition(self.isAirConditionerActive, false); -- setEvent: is not frozen
				end;
			end;
		end;
		if self.airConditionerSound ~= nil then
			if self.isAirConditionerActive then
				if not self.airConditionerSoundEnabled then
					playSample(self.airConditionerSound, 0, self.airConditionerSoundVolume, 0);
					setSamplePitch(self.airConditionerSound, self.airConditionerSoundPitch);
					self.airConditionerSoundEnabled = true;
				end;
			else
				if self.airConditionerSoundEnabled then
					stopSample(self.airConditionerSound);
					self.airConditionerSoundEnabled = false;
				end;
			end;
		end;
	end;
end;

function FreezingWindows:onLeave()

					stopSample(self.airConditionerSound);
					self.airConditionerSoundEnabled = false;

end;

function FreezingWindows:draw()
end;

function FreezingWindows:setWindowCondition(isAirConditionerActive, isFrozen, noEventSend)
	-- SetWindowCondition(self, isAirConditionerActive, isFrozen, noEventSend)
	if isAirConditionerActive ~= self.isAirConditionerActive then
		self.isAirConditionerActive = isAirConditionerActive;
	end;
	if isFrozen ~= self.isFrozen then
		self.isFrozen = isFrozen;
	end;
	self.freezeAnimParts = self.isFrozen;
end;

-- to do: MP Event
